﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectMachine
{
    /// <summary>
    /// Расширение для класса DrawningMachine
    /// </summary>
    internal static class ExtentionTank
    {
        /// <summary>
        /// Разделитель для записи информации по объекту в файл
        /// </summary>
        private static readonly char _separatorForObject = ':';
        /// <summary>
        /// Создание объекта из строки
        /// </summary>
        /// <param name="info"></param>
        /// <returns></returns>
        public static DrawningMachine CreateDrawningMachine(this string info)
        {
            string[] strs = info.Split(_separatorForObject);
            if (strs.Length == 3)
            {
                return new DrawningMachine(Convert.ToInt32(strs[0]),
                Convert.ToInt32(strs[1]), Color.FromName(strs[2]));
            }
            if (strs.Length == 6)
            {
                return new DrawningTank(Convert.ToInt32(strs[0]),
                Convert.ToInt32(strs[1]), Color.FromName(strs[2]),
                Color.FromName(strs[3]), Convert.ToBoolean(strs[4]),
               Convert.ToBoolean(strs[5]));
            }
            return null;
        }
        /// <summary>
        /// Получение данных для сохранения в файл
        /// </summary>
        /// <param name="drawningMachine"></param>
        /// <returns></returns>
        public static string GetDataForSave(this DrawningMachine drawningMachine)
        {
            var machine = drawningMachine.Machine;
            var str = $"{machine.Speed}{_separatorForObject}{machine.Weight}{_separatorForObject}{machine.BodyColor.Name}";
            if (machine is not EntityTank tank)
            {
                return str;
            }
            return
           $"{str}{_separatorForObject}{tank.DopColor.Name}{_separatorForObject}{tank.Turret}{_separatorForObject}{tank.Gun}";
        }
    }
}
